PLACE	0000H		; localiza bloco de cdigo

inicio:
	MOV	SP, 100H	; incializa SP (isto , SSP) (pilha de sistema)
	MOV	BTE, tab	; tabela de excepes
	EI0			; permite interrupo 0
	EI

	CALL	X		; invoca a rotina X (usando a pilha do sistema e o SSP)

	SET	RE, 14	; Pe o bit NP do RE a 1, ou seja, passa para modo de utilizador	

	MOV	SP, 200H	; incializa SP (isto , USP) (pilha de utilizador)
	CALL	X		; invoca a rotina X (usando a pilha do Utilizador e o USP)

	CLR	RE, 14	; Pe o bit NP do RE a 0, ou seja, tenta passar para modo de sistema	

	SWE	32		; invoca a primeira excepo de utilizador (>=32), simulando uma chamada ao sistema

fim:	JMP	fim		; fim do programa

X:	PUSH	R1		; estas instrues usam o SSP ou o USP, consoante o valor de NP
	POP	R1
	RET

rot_int0:			; rotina de atendimento da interrupo 0
	PUSH	R2
	POP	R2
	RFE

erro:	JMP	erro		; erro

erro_sistema:		; erro de sistema (acesso ilegal em modo Utilizador)
	RFE			; neste exemplo, ignora-se este erro (mas num sistema a srio deveria
				; terminar o programa, reportanto o erro)

util0:			; excepo de utilizador (simula uma chamada ao sistema). Executa em modo Sistema
	PUSH	R0		; usa a pilha de sistema
	POP	R0
	RFE			; retorna para modo Utilizador

tab:				; tabela de excepes pre-definidas (ver tabela A.8)
	WORD	rot_int0	; 0 - interrupo 0
	WORD	erro		; 1 - interrupo 1
	WORD	erro		; 2 - interrupo 2
	WORD	erro		; 3 - interrupo 3
	WORD	erro		; 4 - excepo de excesso
	WORD	erro		; 5 - excepo de diviso por 0
	WORD	erro		; 6 - excepo de cdigo de operao invlido
	WORD	erro		; 7 - excepo de acesso em 16 bits desalinhado
	WORD	erro		; 8 - excepo de busca de instruo desalinhada
	WORD	erro		; 9 - excepo de falta de pgina de dados
	WORD	erro		; 10 - excepo de falta de pgina de instrues
	WORD	erro		; 11 - excepo de acesso de Utilizador a pgina de dados de Sistema
	WORD	erro		; 12 - excepo de acesso de Utilizador a pgina de instrues de Sistema
	WORD	erro		; 13 - excepo de escrita em pgina de dados protegida
	WORD	erro_sistema ; 14 - excepo de execuo de instruo de Sistema em modo Utilizador
	WORD	erro		; 15 - excepo reservada para uso futuro
	WORD	erro		; 16 - excepo reservada para uso futuro
	WORD	erro		; 17 - excepo reservada para uso futuro
	WORD	erro		; 18 - excepo reservada para uso futuro
	WORD	erro		; 19 - excepo reservada para uso futuro
	WORD	erro		; 20 - excepo reservada para uso futuro
	WORD	erro		; 21 - excepo reservada para uso futuro
	WORD	erro		; 22 - excepo reservada para uso futuro
	WORD	erro		; 23 - excepo reservada para uso futuro
	WORD	erro		; 24 - excepo reservada para uso futuro
	WORD	erro		; 25 - excepo reservada para uso futuro
	WORD	erro		; 26 - excepo reservada para uso futuro
	WORD	erro		; 27 - excepo reservada para uso futuro
	WORD	erro		; 28 - excepo reservada para uso futuro
	WORD	erro		; 29 - excepo reservada para uso futuro
	WORD	erro		; 30 - excepo reservada para uso futuro
	WORD	erro		; 31 - excepo reservada para uso futuro
	WORD	util0		; 32 - primeira excepo de utilizador (tipicamente, reservada para uma chamada
				; de sistema)

